/*
 * Ben NanoNote configuration parameters.
 *
 * Copyright (C) 2009 Qi Hardware Inc.
 * Authors: Xiangfu Liu <xiangfu@openmobilefree.net>
 * Copyright (C) 2015, 2016, 2017 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __NANONOTE_H__
#define __NANONOTE_H__

/*
 * GPIO definition
 * See: http://en.qi-hardware.com/wiki/Hardware_basics
 */

#define GPIO_PORT_AUDIO			1

#define	GPIO_AUDIO_EN			29		/* audio output enable */
#define GPIO_COB_TEST			30		/* test point TP5 */

/* LCD */

#define GPIO_PORT_LCD			2

#define GPIO_LCD_CS			21
#define SPEN				GPIO_LCD_CS	/* serial command enable */
#define SPDA				22		/* serial command data */
#define SPCK				23		/* serial command clock */

#define GPIO_SLCD8_MASK			0x003c00ff	/* SLCD 8-bit pins */

/* JTAG */

#define GPIO_PORT_JTAG			2

#define GPIO_JTAG_UART_EN		31		/* select UART on pad 147 */

/* Sound/noise */

#define GPIO_PORT_AMP			3
#define GPIO_PORT_BUZZ			3

#define GPIO_AMP_EN			4		/* speaker enable */
#define	GPIO_BUZZ_PWM			27		/* buzzer (PWM4) */

/* USB */

#define GPIO_PORT_USB			3

#define	GPIO_USB_DETECT			28

/* Power */

#define GPIO_PORT_POWER			3

#define GPIO_POWER			29		/* power button */

/* SD/MMC */

#define GPIO_PORT_MSC			3
#define GPIO_PORT_SD			3

#define	GPIO_SD_DETECT			0
#define GPIO_SD_CD_N			GPIO_SD_DETECT	/* SD Card insert detect */
#define GPIO_SDPW_EN			2
#define GPIO_SD_VCC_EN_N		GPIO_SDPW_EN	/* SD Card Power Enable */
#define GPIO_SD_CMD			8
#define GPIO_MSC_MASK			0x00003f00

/* Other details. */

#define GPIO_KEYIN_COUNT		8
#define GPIO_KEYOUT_COUNT		8

#define GPIO_IRQ2			IRQ_GPIO2	/* IRQ for keyboard */
#define GPIO_IRQ3			IRQ_GPIO3	/* IRQ for power button */

#define GPIO_REGION_SIZE		0x10000

#endif /* __NANONOTE_H__ */
